###################################################
### chunk number 1: 
###################################################
#line 565 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
options(prompt= "R> ", useFancyQuotes = FALSE)


###################################################
### chunk number 2: 
###################################################
#line 569 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
library("plm")
#library(nlme)
#library(MASS)
#library(bdsmatrix)
#source("~/R/plm/chargement.R")


###################################################
### chunk number 3: 
###################################################
#line 584 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
data("EmplUK", package="plm")
data("Produc", package="plm")
data("Grunfeld", package="plm")
data("Wages",package="plm")



###################################################
### chunk number 4: setdata1
###################################################
#line 602 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
head(Grunfeld)
E <- pdata.frame(EmplUK, index = c("firm", "year"), drop.index = TRUE, row.names = TRUE)
head(E)
head(attr(E, "index"))


###################################################
### chunk number 5: 
###################################################
#line 621 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
summary(E$emp)
head(as.matrix(E$emp))


###################################################
### chunk number 6: 
###################################################
#line 669 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
head(lag(E$emp, 0:2))


###################################################
### chunk number 7: 
###################################################
#line 679 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
head(diff(E$emp), 10)
head(lag(E$emp, 2), 10)
head(Within(E$emp))
head(between(E$emp), 4)
head(Between(E$emp), 10)



###################################################
### chunk number 8: 
###################################################
#line 703 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
emp~wage+capital|lag(wage,1)+capital
emp~wage+capital|.-wage+lag(wage,1)


###################################################
### chunk number 9: 
###################################################
#line 734 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
grun.fe <- plm(inv~value+capital,data=Grunfeld,model="within")
grun.re <- plm(inv~value+capital,data=Grunfeld,model="random")


###################################################
### chunk number 10: 
###################################################
#line 739 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
summary(grun.re)


###################################################
### chunk number 11: 
###################################################
#line 751 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
fixef(grun.fe, type = 'dmean')


###################################################
### chunk number 12: 
###################################################
#line 760 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
summary(fixef(grun.fe, type = 'dmean'))


###################################################
### chunk number 13: 
###################################################
#line 767 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
grun.twfe <- plm(inv~value+capital,data=Grunfeld,model="within",effect="twoways")
fixef(grun.twfe,effect="time")


###################################################
### chunk number 14: 
###################################################
#line 793 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
grun.amem <- plm(inv~value+capital,data=Grunfeld,model="random",random.method="amemiya")


###################################################
### chunk number 15: 
###################################################
#line 801 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
ercomp(inv~value+capital, data=Grunfeld, method = "amemiya", effect = "twoways")


###################################################
### chunk number 16: 
###################################################
#line 818 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
grun.tways <- plm(inv~value+capital,data=Grunfeld,effect="twoways",model="random",random.method="amemiya")
summary(grun.tways)


###################################################
### chunk number 17: 
###################################################
#line 843 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
data("Hedonic", package = "plm")
Hed <- plm(mv~crim+zn+indus+chas+nox+rm+age+dis+rad+tax+ptratio+blacks+lstat, Hedonic, model = "random", index = "townid")
summary(Hed)


###################################################
### chunk number 18: 
###################################################
#line 865 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
data("Crime", package = "plm")
cr <- plm(log(crmrte) ~ log(prbarr) + log(polpc) + log(prbconv) +
         log(prbpris) + log(avgsen) + log(density) + log(wcon) + 
         log(wtuc) + log(wtrd) + log(wfir) + log(wser) + log(wmfg) + 
         log(wfed) + log(wsta) + log(wloc) + log(pctymle) + log(pctmin) + 
         region + smsa + factor(year) | . - log(prbarr) -log(polpc) + 
         log(taxpc) + log(mix), data = Crime,
         model = "random")
summary(cr)


###################################################
### chunk number 19: 
###################################################
#line 881 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
ht <- pht(lwage~wks+south+smsa+married+exp+I(exp^2)+
          bluecol+ind+union+sex+black+ed | 
          sex+black+bluecol+south+smsa+ind,
          data=Wages,index=595)
summary(ht)


###################################################
### chunk number 20: grunfeld.within
###################################################
#line 922 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
grun.varw <- pvcm(inv~value+capital,data=Grunfeld,model="within")
grun.varr <- pvcm(inv~value+capital,data=Grunfeld,model="random")
summary(grun.varr)


###################################################
### chunk number 21: gmm
###################################################
#line 1068 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
emp.gmm <- pgmm(log(emp)~lag(log(emp), 1:2)+lag(log(wage), 0:1)+log(capital)+lag(log(output), 0:1)|lag(log(emp), 2:99),EmplUK,effect="twoways",model="twosteps")
summary(emp.gmm)


###################################################
### chunk number 22: gmm2
###################################################
#line 1079 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
z2 <- pgmm(log(emp) ~ lag(log(emp), 1)+ lag(log(wage), 0:1) +
           lag(log(capital), 0:1) | lag(log(emp), 2:99) +
           lag(log(wage), 2:99) + lag(log(capital), 2:99),        
           data = EmplUK, effect = "twoways", model = "onestep", 
           transformation = "ld")
summary(z2, robust = TRUE)


###################################################
### chunk number 23: pggls
###################################################
#line 1131 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
zz <- pggls(log(emp)~log(wage)+log(capital),data=EmplUK,model="random")
summary(zz)


###################################################
### chunk number 24: 
###################################################
#line 1140 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
zz <- pggls(log(emp)~log(wage)+log(capital),data=EmplUK,model="within")


###################################################
### chunk number 25: 
###################################################
#line 1180 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
znp <- pvcm(inv~value+capital,data=Grunfeld,model="within")
zplm <- plm(inv~value+capital,data=Grunfeld)
pooltest(zplm,znp)


###################################################
### chunk number 26: 
###################################################
#line 1189 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
pooltest(inv~value+capital,data=Grunfeld,model="within")


###################################################
### chunk number 27: 
###################################################
#line 1218 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
g <- plm(inv ~ value + capital,data=Grunfeld,model="pooling")
plmtest(g,effect="twoways",type="ghm")


###################################################
### chunk number 28: 
###################################################
#line 1225 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
plmtest(inv~value+capital,data=Grunfeld,effect="twoways",type="ghm")


###################################################
### chunk number 29: 
###################################################
#line 1236 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
gw <- plm(inv ~ value + capital,data=Grunfeld,effect="twoways",model="within")
gp <- plm(inv ~ value + capital,data=Grunfeld,model="pooling")
pFtest(gw,gp)


###################################################
### chunk number 30: 
###################################################
#line 1242 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
pFtest(inv~value+capital,data=Grunfeld,effect="twoways")


###################################################
### chunk number 31: 
###################################################
#line 1254 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
gw <- plm(inv~value+capital,data=Grunfeld,model="within")
gr <- plm(inv~value+capital,data=Grunfeld,model="random")
phtest(gw, gr)


###################################################
### chunk number 32: wtest
###################################################
#line 1332 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
pwtest(log(gsp)~log(pcap)+log(pc)+log(emp)+unemp, data=Produc)


###################################################
### chunk number 33: pbsytestJoint
###################################################
#line 1346 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
pbsytest(log(gsp)~log(pcap)+log(pc)+log(emp)+unemp,data=Produc,test="j")


###################################################
### chunk number 34: pbsytestAR
###################################################
#line 1381 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
pbsytest(log(gsp)~log(pcap)+log(pc)+log(emp)+unemp,data=Produc)


###################################################
### chunk number 35: pbsytestRE
###################################################
#line 1390 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
pbsytest(log(gsp)~log(pcap)+log(pc)+log(emp)+unemp,data=Produc,test="re")


###################################################
### chunk number 36: pbltest
###################################################
#line 1406 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
pbltest(log(gsp)~log(pcap)+log(pc)+log(emp)+unemp,data=Produc,alternative="onesided")


###################################################
### chunk number 37: generalAR
###################################################
#line 1475 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
## this can be taken away as soon as attached to plm.rnw
grun.fe <- plm(inv ~ value + capital, data = Grunfeld, model = "within")
pbgtest(grun.fe, order=2)


###################################################
### chunk number 38: pwartest
###################################################
#line 1513 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
pwartest(log(emp) ~ log(wage) + log(capital), data=EmplUK)


###################################################
### chunk number 39: pwfdtest1
###################################################
#line 1555 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
pwfdtest(log(emp) ~ log(wage) + log(capital), data=EmplUK)


###################################################
### chunk number 40: pwfdtest2
###################################################
#line 1561 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
pwfdtest(log(emp) ~ log(wage) + log(capital), data=EmplUK, h0="fe")


###################################################
### chunk number 41: pcdtest1
###################################################
#line 1651 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
pcdtest(inv~value+capital, data=Grunfeld)


###################################################
### chunk number 42: pcdtest2
###################################################
#line 1671 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
pcdtest(inv~value+capital, data=Grunfeld, model="within")


###################################################
### chunk number 43: 
###################################################
#line 1916 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
library("lmtest")
re <- plm(inv~value+capital,data=Grunfeld,model="random")
coeftest(re,vcovHC)


###################################################
### chunk number 44: 
###################################################
#line 1926 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
coeftest(re,vcovHC(re,method="white2",type="HC3"))


###################################################
### chunk number 45: 
###################################################
#line 1937 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
waldtest(re,update(re,.~.-capital),vcov=function(x) vcovHC(x,method="white2",type="HC3"))


###################################################
### chunk number 46: 
###################################################
#line 1943 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
library("car")
linear.hypothesis(re, "2*value=capital", vcov.=vcovHC)


###################################################
### chunk number 47: re
###################################################
#line 2144 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"

reGLS<-plm(inv~value+capital,data=Grunfeld,model="random")

reML<-lme(inv~value+capital,data=Grunfeld,random=~1|firm)

coef(reGLS)

summary(reML)$coef$fixed



###################################################
### chunk number 48: vcmrand
###################################################
#line 2171 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
vcm<-pvcm(inv~value+capital,data=Grunfeld,model="random",effect="time")

vcmML<-lme(inv~value+capital,data=Grunfeld,random=~value+capital|year)

coef(vcm)

summary(vcmML)$coef$fixed



###################################################
### chunk number 49: vcmfixed
###################################################
#line 2190 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
vcmf<-pvcm(inv~value+capital,data=Grunfeld,model="within",effect="time")

vcmfML<-lmList(inv~value+capital|year,data=Grunfeld)



###################################################
### chunk number 50: gglsre
###################################################
#line 2209 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
sGrunfeld <- Grunfeld[Grunfeld$firm%in%4:6,]

ggls<-pggls(inv~value+capital,data=sGrunfeld,model="random")

gglsML<-gls(inv~value+capital,data=sGrunfeld,
            correlation=corSymm(form=~1|year))

coef(ggls)

summary(gglsML)$coef


###################################################
### chunk number 51: lmAR1
###################################################
#line 2240 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
Grunfeld$year <- as.numeric(as.character(Grunfeld$year))
lmAR1ML<-gls(inv~value+capital,data=Grunfeld,
             correlation=corAR1(0,form=~year|firm))


###################################################
### chunk number 52: reAR1
###################################################
#line 2251 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
reAR1ML<-lme(inv~value+capital,data=Grunfeld,random=~1|firm,
             correlation=corAR1(0,form=~year|firm))


###################################################
### chunk number 53: fetchcoefs
###################################################
#line 2259 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
summary(reAR1ML)$coef$fixed
coef(reAR1ML$modelStruct$corStruct,unconstrained=FALSE)


###################################################
### chunk number 54: LRar
###################################################
#line 2286 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
lmML<-gls(inv~value+capital,data=Grunfeld)
anova(lmML,lmAR1ML)


###################################################
### chunk number 55: LRarsubRE
###################################################
#line 2295 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
anova(reML,reAR1ML)


###################################################
### chunk number 56: LRre
###################################################
#line 2303 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
anova(lmML,reML)


###################################################
### chunk number 57: LRresubAR
###################################################
#line 2313 "d:/Rcompile/CRANpkg/local/2.12/plm/inst/doc/plm.rnw"
anova(lmAR1ML,reAR1ML)


